aboutsummaryrefslogtreecommitdiffstats
path: root/etc/woodpecker/try-all-builds.sh
diff options
context:
space:
mode:
authorNRK <nrk@disroot.org>2022-10-07 15:37:44 +0200
committerNRK <nrk@disroot.org>2022-10-07 15:37:44 +0200
commitaa56aa23030e9f8680d5ef366f2bd72fd342c14f (patch)
treec0abf72eeb08effe4806ad141d2f4f04fe6f0ecd /etc/woodpecker/try-all-builds.sh
parent85fffbb277418dfc5e03fc8e01335553333d8049 (diff)
downloadnsxiv-aa56aa23030e9f8680d5ef366f2bd72fd342c14f.tar.zst
[ci]: try building all combination with tcc (#338)
this will hopefully catch issues like [337] in the future. not using gcc and/or clang since we have 5 build options right now, which means 2^5 = 32 different combination. using gcc/clang would take too much resources and time; meanwhile tcc is lightning fast. [337]: https://codeberg.org/nsxiv/nsxiv/pulls/337 Reviewed-on: https://codeberg.org/nsxiv/nsxiv/pulls/338 Reviewed-by: eylles <eylles@noreply.codeberg.org>
Diffstat (limited to 'etc/woodpecker/try-all-builds.sh')
-rwxr-xr-xetc/woodpecker/try-all-builds.sh38
1 files changed, 38 insertions, 0 deletions
diff --git a/etc/woodpecker/try-all-builds.sh b/etc/woodpecker/try-all-builds.sh
new file mode 100755
index 0000000..89e41f1
--- /dev/null
+++ b/etc/woodpecker/try-all-builds.sh
@@ -0,0 +1,38 @@
+#!/bin/sh
+#
+# Shell script that checks for all possible build combination with TCC.
+# Usage: call the script while in the nsxiv root directory
+
+set -- $(grep -o '^HAVE_[[:alpha:]]* ' config.mk)
+CFLAGS="$(sed '/^#/d' etc/woodpecker/CFLAGS | paste -d ' ' -s)"
+z=$(echo "2 ^ $#" | bc)
+
+print_opt_name() {
+ shift "$(( $1 + 1 ))"
+ printf "%s=" "$1"
+}
+
+print_opt_arg() {
+ bn=$(echo "$1 / (2 ^ $2)" | bc)
+ printf "%d " $(( bn % 2 ))
+}
+
+n=0
+while [ "$n" -lt "$z" ]; do
+ i=0
+ while [ "$i" -lt "$#" ]; do
+ print_opt_name "$i" "$@"
+ print_opt_arg "$n" "$i"
+ i=$((i + 1))
+ done | tee "/dev/stderr" | (
+ make clean
+ if ! xargs make -j"$(nproc)" CC=tcc CFLAGS="$CFLAGS" LDFLAGS="$CFLAGS"; then
+ echo "[FAILED]" >&2
+ exit 1
+ else
+ echo "[SUCCESS]" >&2
+ fi
+ )
+ [ "$?" -ne 0 ] && exit "$?"
+ n=$((n + 1))
+done >/dev/null